--- iceweasel-17.0.orig/js/src/gc/Memory.cpp	2012-12-06 01:06:02.840996806 +0800
+++ iceweasel-17.0/js/src/gc/Memory.cpp	2012-12-06 01:07:14.737356955 +0800
@@ -83,9 +83,13 @@
 bool
 MarkPagesUnused(void *p, size_t size)
 {
+#if !defined(__powerpc__) and !defined(__mips__)
     JS_ASSERT(uintptr_t(p) % PageSize == 0);
     LPVOID p2 = VirtualAlloc(p, size, MEM_RESET, PAGE_READWRITE);
     return p2 == p;
+#else
+    return true;
+#endif
 }
 
 bool
--- iceweasel-17.0.orig/js/src/gc/Heap.h	2012-12-06 02:13:50.729632056 +0800
+++ iceweasel-17.0/js/src/gc/Heap.h	2012-12-06 02:15:05.602630426 +0800
@@ -110,6 +110,8 @@
  */
 #if defined(SOLARIS) && (defined(__sparc) || defined(__sparcv9))
 const size_t PageShift = 13;
+#elif defined(__mips__)
+const size_t PageShift = 14;
 #else
 const size_t PageShift = 12;
 #endif
